diff --git a/gcc/analyzer/region-model2.cc b/gcc/analyzer/region-model2.cc
index d9c4fffa68c..c7fe5f2e458 100644
--- a/gcc/analyzer/region-model2.cc
+++ b/gcc/analyzer/region-model2.cc
@@ -6723,7 +6737,7 @@ region_model2::get_or_create_mem_ref (tree type,
   region2 *array_view_reg = get_or_create_view (raw_reg, array_type, ctxt);
   array_region2 *array_reg = get_region2 <array_region2> (array_view_reg);
 
-  svalue2 *index_sval
+  const svalue2 *index_sval
     = convert_byte_offset_to_array_index (ptr_type, offset_sval);
 
   region2 *element_reg
@@ -6740,8 +6754,8 @@ region_model2::get_or_create_mem_ref (tree type,
 
 region2_id
 region_model2::get_or_create_pointer_plus_expr (tree type,
-					       svalue2 *ptr_sval,
-					       svalue2 *offset_in_bytes_sval,
+					       const svalue2 *ptr_sval,
+					       const svalue2 *offset_in_bytes_sval,
 					       region_model2_context *ctxt)
 {
   return get_or_create_mem_ref (type,
@@ -6790,11 +6804,12 @@ region_model2::get_fndecl_for_call (const gcall *call,
   tree fn_ptr = gimple_call_fn (call);
   if (fn_ptr == NULL_TREE)
     return NULL_TREE;
-  svalue2 *fn_ptr_sval = get_rvalue (fn_ptr, ctxt);
-  if (region_svalue2 *fn_ptr_ptr = fn_ptr_sval->dyn_cast_region_svalue2 ())
+  const svalue2 *fn_ptr_sval = get_rvalue (fn_ptr, ctxt);
+  if (const region_svalue2 *fn_ptr_ptr
+	= fn_ptr_sval->dyn_cast_region_svalue2 ())
     {
-      region2 *reg = fn_ptr_ptr->get_pointee ();
-      if (function_region2 *fn_reg = reg->dyn_cast_function_region2 ())
+      const region2 *reg = fn_ptr_ptr->get_pointee ();
+      if (const function_region2 *fn_reg = reg->dyn_cast_function_region2 ())
 	{
 	  tree fn_decl = fn_reg->get_fndecl ();
 	  cgraph_node *node = cgraph_node::get (fn_decl);
@@ -6847,20 +6862,20 @@ region_model2::append_ssa_names_cb (const region2 *base_reg,
 
 /* FIXME.  */
 
-region2 *
-region_model2::create_region_for_heap_alloc (svalue2 *size_in_bytes)
+const region2 *
+region_model2::create_region_for_heap_alloc (const svalue2 *size_in_bytes)
 {
-  region2 *reg = m_mgr->create_region_for_heap_alloc ();
+  const region2 *reg = m_mgr->create_region_for_heap_alloc ();
   record_dynamic_extents (reg, size_in_bytes);
   return reg;
 }
 
 /* FIXME.  */
 
-region2 *
-region_model2::create_region_for_alloca (svalue2 *size_in_bytes)
+const region2 *
+region_model2::create_region_for_alloca (const svalue2 *size_in_bytes)
 {
-  region2 *reg = m_mgr->create_region_for_alloca (m_current_frame);
+  const region2 *reg = m_mgr->create_region_for_alloca (m_current_frame);
   record_dynamic_extents (reg, size_in_bytes);
   return reg;
 }
@@ -6868,10 +6883,11 @@ region_model2::create_region_for_alloca (svalue2 *size_in_bytes)
 /* FIXME.  */
 
 void
-region_model2::record_dynamic_extents (region2 *reg, svalue2 *size_in_bytes)
+region_model2::record_dynamic_extents (const region2 *reg,
+				       const svalue2 *size_in_bytes)
 {
 #if 0
-  svalue2 *extents_sval = m_mgr->get_or_create_extents_svalue2 (reg);
+  const svalue2 *extents_sval = m_mgr->get_or_create_extents_svalue2 (reg);
   add_constraint (extents_sval, EQ_EXPR, size_in_bytes);
   /* TODO: This needs the ability to add constraints in the model based on an
      svalue2.  */
@@ -6945,13 +6961,13 @@ model_merger::dump () const
    Return true if the merger is possible, false otherwise.  */
 
 bool
-model_merger::can_merge_values_p (svalue2 *sval_a,
-				  svalue2 *sval_b,
-				  svalue2 **merged_sval)
+model_merger::can_merge_values_p (const svalue2 *sval_a,
+				  const svalue2 *sval_b,
+				  const svalue2 **merged_sval)
 {
   gcc_assert (merged_sval);
-  svalue2 *sval_a = m_model_a->get_svalue2 (sid_a);
-  svalue2 *sval_b = m_model_b->get_svalue2 (sid_b);
+  const svalue2 *sval_a = m_model_a->get_svalue2 (sid_a);
+  const svalue2 *sval_b = m_model_b->get_svalue2 (sid_b);
 
   /* If both are NULL, then the "values" are trivially mergeable.  */
   if (!sval_a && !sval_b)
@@ -6964,9 +6980,9 @@ model_merger::can_merge_values_p (svalue2 *sval_a,
 
   /* Have they both already been mapped to the same new svalue2_id?
      If so, use it.  */
-  svalue2 *sval_a_in_m
+  const svalue2 *sval_a_in_m
     = m_sval_mapping->m_map_from_a_to_m.get_dst_for_src (sid_a);
-  svalue2 *sval_b_in_m
+  const svalue2 *sval_b_in_m
     = m_sval_mapping->m_map_from_b_to_m.get_dst_for_src (sid_b);
   if (!sid_a_in_m.null_p ()
       && !sid_b_in_m.null_p ()
@@ -6985,7 +7001,7 @@ model_merger::can_merge_values_p (svalue2 *sval_a,
   if (sval_a->get_kind () != sval_b->get_kind ()
       || sval_a->get_kind () == SK_UNKNOWN)
     {
-      svalue2 *merged_sval = new unknown_svalue2 (type);
+      const svalue2 *merged_sval = new unknown_svalue2 (type);
       *merged_sval = m_merged_model->add_svalue2 (merged_sval);
       record_svalue2s (sid_a, sid_b, *merged_sval);
       return true;
@@ -7003,8 +7019,10 @@ model_merger::can_merge_values_p (svalue2 *sval_a,
       {
 	/* If we have two region2 pointers, then we can merge (possibly to
 	   "unknown").  */
-	const region_svalue2 &region2_sval_a = *as_a <region_svalue2 *> (sval_a);
-	const region_svalue2 &region2_sval_b = *as_a <region_svalue2 *> (sval_b);
+	const region_svalue2 &region2_sval_a
+	  = *as_a <const region_svalue2 *> (sval_a);
+	const region_svalue2 &region2_sval_b
+	  = *as_a <const region_svalue2 *> (sval_b);
 	region_svalue2::merge_values (region2_sval_a, region2_sval_b,
 				     merged_sval, type,
 				     this);
@@ -7015,8 +7033,10 @@ model_merger::can_merge_values_p (svalue2 *sval_a,
     case SK_CONSTANT:
       {
 	/* If we have two constants, then we can merge.  */
-	const constant_svalue2 &cst_sval_a = *as_a <constant_svalue2 *> (sval_a);
-	const constant_svalue2 &cst_sval_b = *as_a <constant_svalue2 *> (sval_b);
+	const constant_svalue2 &cst_sval_a
+	  = *as_a <const constant_svalue2 *> (sval_a);
+	const constant_svalue2 &cst_sval_b
+	  = *as_a <const constant_svalue2 *> (sval_b);
 	constant_svalue2::merge_values (cst_sval_a, cst_sval_b,
 				       merged_sval, this);
 	record_svalue2s (sid_a, sid_b, *merged_sval);
@@ -7047,9 +7067,9 @@ model_merger::record_region2s (region2 *a_reg,
    correspond to MERGED_SVAL in the merged model.  */
 
 void
-model_merger::record_svalue2s (svalue2 *a_sval,
-			      svalue2 *b_sval,
-			      svalue2 *merged_sval)
+model_merger::record_svalue2s (const svalue2 *a_sval,
+			      const svalue2 *b_sval,
+			      const svalue2 *merged_sval)
 {
   gcc_assert (m_sval_mapping);
   m_sval_mapping->m_map_from_a_to_m.put (a_sval, merged_sval);
@@ -7180,7 +7200,7 @@ test_tree_cmp_on_constants ()
 void
 assert_condition2 (const location &loc,
 		   region_model2 &model,
-		   svalue2 *lhs, tree_code op, svalue2 *rhs,
+		   const svalue2 *lhs, tree_code op, const svalue2 *rhs,
 		   tristate expected)
 {
   tristate actual = model.eval_condition (lhs, op, rhs);
@@ -7351,7 +7371,7 @@ test_dump_2 ()
 
   /* Verify get_offset for "c.x".  */
   {
-    region2 *c_x_reg = model.get_lvalue (c_x, NULL);
+    const region2 *c_x_reg = model.get_lvalue (c_x, NULL);
     region_offset offset = c_x_reg->get_offset ();
     ASSERT_EQ (offset.get_base_region (), model.get_lvalue (c, NULL));
     ASSERT_EQ (offset.get_bit_offset (), 0);
@@ -7359,7 +7379,7 @@ test_dump_2 ()
 
   /* Verify get_offset for "c.y".  */
   {
-    region2 *c_y_reg = model.get_lvalue (c_y, NULL);
+    const region2 *c_y_reg = model.get_lvalue (c_y, NULL);
     region_offset offset = c_y_reg->get_offset ();
     ASSERT_EQ (offset.get_base_region (), model.get_lvalue (c, NULL));
     ASSERT_EQ (offset.get_bit_offset (), INT_TYPE_SIZE);
@@ -7437,7 +7457,7 @@ test_get_representative_tree ()
   {
     tree string_cst = build_string (4, "foo");
     region_model2 m;
-    svalue2 *str_sval = m.get_rvalue (string_cst, NULL);
+    const svalue2 *str_sval = m.get_rvalue (string_cst, NULL);
     tree rep = m.get_representative_tree (str_sval);
     ASSERT_EQ (rep, string_cst);
   }
@@ -7446,7 +7466,7 @@ test_get_representative_tree ()
   {
     tree string_cst_ptr = build_string_literal (4, "foo");
     region_model2 m;
-    svalue2 *str_sval = m.get_rvalue (string_cst_ptr, NULL);
+    const svalue2 *str_sval = m.get_rvalue (string_cst_ptr, NULL);
     tree rep = m.get_representative_tree (str_sval);
     ASSERT_DUMP_TREE_EQ (rep, "&\"foo\"[0]");
   }
@@ -7476,8 +7496,8 @@ test_unique_constants ()
   tree const_int_42 = build_int_cst (const_int_type_node, 42);
   ASSERT_NE (int_42, const_int_42);
   /* It should have a different const_svalue2.  */
-  svalue2 *int_42_sval = model.get_rvalue (int_42, &ctxt);
-  svalue2 *const_int_42_sval = model.get_rvalue (const_int_42, &ctxt);
+  const svalue2 *int_42_sval = model.get_rvalue (int_42, &ctxt);
+  const svalue2 *const_int_42_sval = model.get_rvalue (const_int_42, &ctxt);
   ASSERT_NE (int_42_sval, const_int_42_sval);
   /* But they should compare as equal.  */
   ASSERT_CONDITION_TRUE2 (model, int_42_sval, EQ_EXPR, const_int_42_sval);
@@ -7497,9 +7517,9 @@ test_svalue2_equality ()
   /* Create pairs instances of the various subclasses of svalue2,
      testing for hash and equality between (this, this) and
      (this, other of same subclass). */
-  svalue2 *ptr_to_r0
+  const svalue2 *ptr_to_r0
     = new region_svalue2 (ptr_type_node, region2_id::from_int (0));
-  svalue2 *ptr_to_r1
+  const svalue2 *ptr_to_r1
     = new region_svalue2 (ptr_type_node, region2_id::from_int (1));
 
   ASSERT_EQ (ptr_to_r0->hash (), ptr_to_r0->hash ());
@@ -7508,8 +7528,8 @@ test_svalue2_equality ()
   ASSERT_NE (ptr_to_r0->hash (), ptr_to_r1->hash ());
   ASSERT_NE (*ptr_to_r0, *ptr_to_r1);
 
-  svalue2 *cst_int_42 = new constant_svalue2 (int_42);
-  svalue2 *cst_int_0 = new constant_svalue2 (int_0);
+  const svalue2 *cst_int_42 = new constant_svalue2 (int_42);
+  const svalue2 *cst_int_0 = new constant_svalue2 (int_0);
 
   ASSERT_EQ (cst_int_42->hash (), cst_int_42->hash ());
   ASSERT_EQ (*cst_int_42, *cst_int_42);
@@ -7517,8 +7537,8 @@ test_svalue2_equality ()
   ASSERT_NE (cst_int_42->hash (), cst_int_0->hash ());
   ASSERT_NE (*cst_int_42, *cst_int_0);
 
-  svalue2 *uninit = new poisoned_svalue2 (POISON_KIND_UNINIT, NULL_TREE);
-  svalue2 *freed = new poisoned_svalue2 (POISON_KIND_FREED, NULL_TREE);
+  const svalue2 *uninit = new poisoned_svalue2 (POISON_KIND_UNINIT, NULL_TREE);
+  const svalue2 *freed = new poisoned_svalue2 (POISON_KIND_FREED, NULL_TREE);
 
   ASSERT_EQ (uninit->hash (), uninit->hash ());
   ASSERT_EQ (*uninit, *uninit);
@@ -7526,8 +7546,8 @@ test_svalue2_equality ()
   ASSERT_NE (uninit->hash (), freed->hash ());
   ASSERT_NE (*uninit, *freed);
 
-  svalue2 *unknown_0 = new unknown_svalue2 (ptr_type_node);
-  svalue2 *unknown_1 = new unknown_svalue2 (ptr_type_node);
+  const svalue2 *unknown_0 = new unknown_svalue2 (ptr_type_node);
+  const svalue2 *unknown_1 = new unknown_svalue2 (ptr_type_node);
   ASSERT_EQ (unknown_0->hash (), unknown_0->hash ());
   ASSERT_EQ (*unknown_0, *unknown_0);
   ASSERT_EQ (*unknown_1, *unknown_1);
@@ -7587,7 +7607,7 @@ test_svalue2_folding ()
 #define NUM_CSTS 10
   tree cst_int[NUM_CSTS];
   region_model2_manager mgr;
-  svalue2 *cst_sval[NUM_CSTS];
+  const svalue2 *cst_sval[NUM_CSTS];
   for (int i = 0; i < NUM_CSTS; i++)
     {
       cst_int[i] = build_int_cst (integer_type_node, i);
@@ -7603,29 +7623,29 @@ test_svalue2_folding ()
 	  ASSERT_NE (cst_sval[i], cst_sval[j]);
 	if (i + j < NUM_CSTS)
 	  {
-	    svalue2 *sum
+	    const svalue2 *sum
 	      = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
 					 cst_sval[i], cst_sval[j]);
 	    ASSERT_EQ (sum, cst_sval[i + j]);
 	  }
 	if (i - j >= 0)
 	  {
-	    svalue2 *difference
+	    const svalue2 *difference
 	      = mgr.get_or_create_binop (integer_type_node, MINUS_EXPR,
 					 cst_sval[i], cst_sval[j]);
 	    ASSERT_EQ (difference, cst_sval[i - j]);
 	  }
 	if (i * j < NUM_CSTS)
 	  {
-	    svalue2 *product
+	    const svalue2 *product
 	      = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
 					 cst_sval[i], cst_sval[j]);
 	    ASSERT_EQ (product, cst_sval[i * j]);
 	  }
-	svalue2 *eq = mgr.get_or_create_binop (integer_type_node, EQ_EXPR,
+	const svalue2 *eq = mgr.get_or_create_binop (integer_type_node, EQ_EXPR,
 					       cst_sval[i], cst_sval[j]);
 	ASSERT_EQ (eq, i == j ? cst_sval[1] : cst_sval [0]);
-	svalue2 *neq = mgr.get_or_create_binop (integer_type_node, NE_EXPR,
+	const svalue2 *neq = mgr.get_or_create_binop (integer_type_node, NE_EXPR,
 						cst_sval[i], cst_sval[j]);
 	ASSERT_EQ (neq, i != j ? cst_sval[1] : cst_sval [0]);
 	// etc
@@ -7636,35 +7656,35 @@ test_svalue2_folding ()
 
   test_region_model2_context ctxt;
   region_model2 model (&mgr);
-  svalue2 *x_init = model.get_rvalue (x, &ctxt);
-  region2 *x_reg = model.get_lvalue (x, &ctxt);
+  const svalue2 *x_init = model.get_rvalue (x, &ctxt);
+  const region2 *x_reg = model.get_lvalue (x, &ctxt);
   ASSERT_EQ (x_init, mgr.get_or_create_initial_value (x_reg));
 
   /* PLUS_EXPR folding.  */
-  svalue2 *x_init_plus_zero
+  const svalue2 *x_init_plus_zero
     = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
 			       x_init, cst_sval[0]);
   ASSERT_EQ (x_init_plus_zero, x_init);
-  svalue2 *zero_plus_x_init
+  const svalue2 *zero_plus_x_init
     = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
 			       cst_sval[0], x_init);
   ASSERT_EQ (zero_plus_x_init, x_init);
 
   /* MULT_EXPR folding.  */
-  svalue2 *x_init_times_zero
+  const svalue2 *x_init_times_zero
     = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
 			       x_init, cst_sval[0]);
   ASSERT_EQ (x_init_times_zero, cst_sval[0]);
-  svalue2 *zero_times_x_init
+  const svalue2 *zero_times_x_init
     = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
 			       cst_sval[0], x_init);
   ASSERT_EQ (zero_times_x_init, cst_sval[0]);
 
-  svalue2 *x_init_times_one
+  const svalue2 *x_init_times_one
     = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
 			       x_init, cst_sval[1]);
   ASSERT_EQ (x_init_times_one, x_init);
-  svalue2 *one_times_x_init
+  const svalue2 *one_times_x_init
     = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
 			       cst_sval[1], x_init);
   ASSERT_EQ (one_times_x_init, x_init);
@@ -7673,13 +7693,13 @@ test_svalue2_folding ()
   // TODO: do we want to use the match-and-simplify DSL for this?
 
   /* TODO: Verify that ((x + 1) + 1) == (x + 2).  */
-  svalue2 *x_init_plus_one
+  const svalue2 *x_init_plus_one
     = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
 			       x_init, cst_sval[1]);
-  svalue2 *x_init_plus_two
+  const svalue2 *x_init_plus_two
     = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
 			       x_init, cst_sval[2]);
-  svalue2 *x_init_plus_one_plus_one
+  const svalue2 *x_init_plus_one_plus_one
     = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
 			       x_init_plus_one, cst_sval[1]);
 #if 0
@@ -7689,7 +7709,7 @@ test_svalue2_folding ()
   /* FIXME: do we want to canonicalize binops to put constants on the RHS ?  */
 }
 #if 0
-/* A subclass of purge_criteria for selftests: purge all svalue2 *instances.  */
+/* A subclass of purge_criteria for selftests: purge all const svalue2 *instances.  */
 
 class purge_all_svalue2_ids : public purge_criteria
 {
@@ -7979,11 +7999,11 @@ test_stack_frames ()
   region_model2 model (&mgr);
 
   /* Push stack frame for "parent_fn".  */
-  region2 *parent_frame_reg
+  const region2 *parent_frame_reg
     = model.push_frame (DECL_STRUCT_FUNCTION (parent_fndecl),
 			NULL, &ctxt);
   ASSERT_EQ (model.get_current_frame (), parent_frame_reg);
-  region2 *a_in_parent_reg = model.get_lvalue (a, &ctxt);
+  const region2 *a_in_parent_reg = model.get_lvalue (a, &ctxt);
   model.set_value (a_in_parent_reg,
 		   model.get_rvalue (int_42, &ctxt),
 		   &ctxt);
@@ -7996,10 +8016,10 @@ test_stack_frames ()
 #endif
 
   /* Push stack frame for "child_fn".  */
-  region2 *child_frame_reg
+  const region2 *child_frame_reg
     = model.push_frame (DECL_STRUCT_FUNCTION (child_fndecl), NULL, &ctxt);
   ASSERT_EQ (model.get_current_frame (), child_frame_reg);
-  region2 *x_in_child_reg = model.get_lvalue (x, &ctxt);
+  const region2 *x_in_child_reg = model.get_lvalue (x, &ctxt);
   model.set_value (x_in_child_reg,
 		   model.get_rvalue (int_0, &ctxt),
 		   &ctxt);
@@ -8012,13 +8032,13 @@ test_stack_frames ()
 #endif
 
   /* Point a global pointer at a local in the child frame:  p = &x.  */
-  region2 *p_in_globals_reg = model.get_lvalue (p, &ctxt);
+  const region2 *p_in_globals_reg = model.get_lvalue (p, &ctxt);
   model.set_value (p_in_globals_reg,
 		   mgr.get_ptr_svalue2 (ptr_type_node, x_in_child_reg),
 		   &ctxt);
 
   /* Point another global pointer at p: q = &p.  */
-  region2 *q_in_globals_reg = model.get_lvalue (q, &ctxt);
+  const region2 *q_in_globals_reg = model.get_lvalue (q, &ctxt);
   model.set_value (q_in_globals_reg,
 		   mgr.get_ptr_svalue2 (ptr_type_node, p_in_globals_reg),
 		   &ctxt);
@@ -8065,7 +8085,7 @@ test_stack_frames ()
 
   /* Verify that p (which was pointing at the local "x" in the popped
      frame) has been poisoned.  */
-  svalue2 *new_p_sval = model.get_rvalue (p, &ctxt);
+  const svalue2 *new_p_sval = model.get_rvalue (p, &ctxt);
 #if 0
   ASSERT_EQ (new_p_sval->get_kind (), svalue2::SK_POISONED);
   ASSERT_EQ (new_p_sval->dyn_cast_poisoned_svalue2 ()->get_poison_kind (),
@@ -8074,7 +8094,7 @@ test_stack_frames ()
 
   /* Verify that q still points to p, in spite of the region2
      renumbering.  */
-  svalue2 *new_q_sval = model.get_rvalue (q, &ctxt);
+  const svalue2 *new_q_sval = model.get_rvalue (q, &ctxt);
   ASSERT_EQ (new_q_sval->get_kind (), svalue2::SK_REGION);
   ASSERT_EQ (new_q_sval->dyn_cast_region_svalue2 ()->get_pointee (),
 	     model.get_lvalue (p, &ctxt));
@@ -8084,7 +8104,7 @@ test_stack_frames ()
 
   /* Verify locals in parent frame.  */
   /* Verify "a" still has its value.  */
-  svalue2 *new_a_sval = model.get_rvalue (a, &ctxt);
+  const svalue2 *new_a_sval = model.get_rvalue (a, &ctxt);
   ASSERT_EQ (new_a_sval->get_kind (), svalue2::SK_CONSTANT);
   ASSERT_EQ (new_a_sval->dyn_cast_constant_svalue2 ()->get_constant (),
 	     int_42);
@@ -8121,14 +8141,14 @@ test_get_representative_path_var ()
   auto_vec<svalue2_id> parm_svals;
   for (int depth = 0; depth < 5; depth++)
     {
-      region2 *frame_reg
+      const region2 *frame_reg
 	= model.push_frame (DECL_STRUCT_FUNCTION (fndecl), NULL, NULL);
-      region2 *reg_n = model.get_lvalue (path_var (n, depth), NULL);
+      const region2 *reg_n = model.get_lvalue (path_var (n, depth), NULL);
       parm_regs.safe_push (rid_n);
 
       ASSERT_EQ (model.get_region2 (rid_n)->get_parent (), frame_reg);
 
-      svalue2 *sval_n
+      const svalue2 *sval_n
 	= model.set_to_new_unknown_value (rid_n, integer_type_node, NULL);
       parm_svals.safe_push (sid_n);
     }
@@ -8279,7 +8299,7 @@ test_model_equality_4 ()
 static void
 assert_region_model2s_merge (tree expr, tree val_a, tree val_b,
 			    region_model2 *out_merged_model,
-			    svalue2 **out_merged_svalue2)
+			    const svalue2 **out_merged_svalue2)
 {
   test_region_model2_context ctxt;
   region_model2 model0;
@@ -8296,7 +8316,7 @@ assert_region_model2s_merge (tree expr, tree val_a, tree val_b,
   /* They should be mergeable.  */
   ASSERT_TRUE (model0.can_merge_with_p (model1, out_merged_model));
 
-  svalue2 *merged_svalue2_sval = out_merged_model->get_rvalue (expr, &ctxt);
+  const svalue2 *merged_svalue2_sval = out_merged_model->get_rvalue (expr, &ctxt);
   *out_merged_svalue2 = out_merged_model->get_svalue2 (merged_svalue2_sval);
 }
 
@@ -8367,7 +8387,7 @@ test_state_merging ()
 	       DECL_STRUCT_FUNCTION (test_fndecl));
     model1.push_frame (DECL_STRUCT_FUNCTION (test_fndecl), NULL, &ctxt);
 
-    svalue2 *sval_a
+    const svalue2 *sval_a
       = model0.set_to_new_unknown_value (model0.get_lvalue (a, &ctxt),
 					 integer_type_node, &ctxt);
     model1.set_to_new_unknown_value (model1.get_lvalue (a, &ctxt),
@@ -8382,7 +8402,7 @@ test_state_merging ()
     ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
     ASSERT_EQ (model0, merged);
     /* In particular, there should be an unknown value for "a".  */
-    svalue2 *merged_a_sval = merged.get_svalue2 (merged.get_rvalue (a, &ctxt));
+    const svalue2 *merged_a_sval = merged.get_svalue2 (merged.get_rvalue (a, &ctxt));
     ASSERT_EQ (merged_a_sval->get_kind (), SK_UNKNOWN);
   }
 
@@ -8391,7 +8411,7 @@ test_state_merging ()
     test_region_model2_context ctxt;
     region_model2 model0;
     region_model2 model1;
-    svalue2 *sval_x
+    const svalue2 *sval_x
       = model0.set_to_new_unknown_value (model0.get_lvalue (x, &ctxt),
 					 integer_type_node, &ctxt);
     model1.set_to_new_unknown_value (model1.get_lvalue (x, &ctxt),
@@ -8406,7 +8426,7 @@ test_state_merging ()
     ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
     ASSERT_EQ (model0, merged);
     /* In particular, there should be an unknown value for "x".  */
-    svalue2 *merged_x_sval = merged.get_svalue2 (merged.get_rvalue (x, &ctxt));
+    const svalue2 *merged_x_sval = merged.get_svalue2 (merged.get_rvalue (x, &ctxt));
     ASSERT_EQ (merged_x_sval->get_kind (), SK_UNKNOWN);
   }
 
@@ -8415,7 +8435,7 @@ test_state_merging ()
   /* Two equal constant values.  */
   {
     region_model2 merged;
-    svalue2 *merged_x_sval;
+    const svalue2 *merged_x_sval;
     assert_region_model2s_merge (x, int_42, int_42, &merged, &merged_x_sval);
 
     /* In particular, there should be a constant value for "x".  */
@@ -8427,7 +8447,7 @@ test_state_merging ()
   /* Two non-equal constant values.  */
   {
     region_model2 merged;
-    svalue2 *merged_x_sval;
+    const svalue2 *merged_x_sval;
     assert_region_model2s_merge (x, int_42, int_113, &merged, &merged_x_sval);
 
     /* In particular, there should be an unknown value for "x".  */
@@ -8437,7 +8457,7 @@ test_state_merging ()
   /* Uninit and constant.  */
   {
     region_model2 merged;
-    svalue2 *merged_x_sval;
+    const svalue2 *merged_x_sval;
     assert_region_model2s_merge (x, NULL_TREE, int_113, &merged, &merged_x_sval);
 
     /* In particular, there should be an unknown value for "x".  */
@@ -8447,7 +8467,7 @@ test_state_merging ()
   /* Constant and uninit.  */
   {
     region_model2 merged;
-    svalue2 *merged_x_sval;
+    const svalue2 *merged_x_sval;
     assert_region_model2s_merge (x, int_42, NULL_TREE, &merged, &merged_x_sval);
 
     /* In particular, there should be an unknown value for "x".  */
@@ -8485,14 +8505,14 @@ test_state_merging ()
   {
     region_model2 merged;
     /* p == &y in both input models.  */
-    svalue2 *merged_p_sval;
+    const svalue2 *merged_p_sval;
     assert_region_model2s_merge (p, addr_of_y, addr_of_y, &merged,
 				&merged_p_sval);
 
     /* We should get p == &y in the merged model.  */
     ASSERT_EQ (merged_p_sval->get_kind (), SK_REGION2);
-    region_svalue2 *merged_p_ptr = merged_p_sval->dyn_cast_region_svalue2 ();
-    region2 *merged_p_star_reg = merged_p_ptr->get_pointee ();
+    region_const svalue2 *merged_p_ptr = merged_p_sval->dyn_cast_region_svalue2 ();
+    const region2 *merged_p_star_reg = merged_p_ptr->get_pointee ();
     ASSERT_EQ (merged_p_star_reg, merged.get_lvalue (y, NULL));
   }
 
@@ -8500,7 +8520,7 @@ test_state_merging ()
   {
     region_model2 merged;
     /* x == &y vs x == &z in the input models.  */
-    svalue2 *merged_x_sval;
+    const svalue2 *merged_x_sval;
     assert_region_model2s_merge (x, addr_of_y, addr_of_z, &merged,
 				&merged_x_sval);
 
@@ -8512,8 +8532,8 @@ test_state_merging ()
   {
     test_region_model2_context ctxt;
     region_model2 model0;
-    region2 *new_reg = model0.add_new_malloc_region2 ();
-    svalue2 *ptr_sval
+    const region2 *new_reg = model0.add_new_malloc_region2 ();
+    const svalue2 *ptr_sval
       = model0.get_or_create_ptr_svalue2 (ptr_type_node, new_reg);
     model0.set_value (model0.get_lvalue (p, &ctxt),
 		      ptr_sval, &ctxt);
@@ -8538,7 +8558,7 @@ test_state_merging ()
   {
     test_region_model2_context ctxt;
     region_model2 model0;
-    svalue2 *sval
+    const svalue2 *sval
       = model0.set_to_new_unknown_value (model0.get_lvalue (x, &ctxt),
 					 integer_type_node, &ctxt);
     model0.set_value (model0.get_lvalue (y, &ctxt), sid, &ctxt);
@@ -8589,9 +8609,9 @@ test_state_merging ()
     test_region_model2_context ctxt;
     region_model2 model0;
 
-    region2 *x_reg = model0.get_lvalue (x, &ctxt);
-    region2 *x_as_ptr = model0.get_or_create_view (x_reg, ptr_type_node,
-						    &ctxt);
+    const region2 *x_reg = model0.get_lvalue (x, &ctxt);
+    const region2 *x_as_ptr = model0.get_or_create_view (x_reg, ptr_type_node,
+							 &ctxt);
     model0.set_value (x_as_ptr, model0.get_rvalue (addr_of_y, &ctxt), &ctxt);
 
     region_model2 model1 (model0);
@@ -8607,19 +8627,19 @@ test_state_merging ()
   {
     region_model2 model0;
     model0.push_frame (DECL_STRUCT_FUNCTION (test_fndecl), NULL, NULL);
-    region2 *q_in_first_frame = model0.get_lvalue (q, NULL);
+    const region2 *q_in_first_frame = model0.get_lvalue (q, NULL);
 
     /* Push a second frame.  */
-    region2 *reg_2nd_frame
+    const region2 *reg_2nd_frame
       = model0.push_frame (DECL_STRUCT_FUNCTION (test_fndecl), NULL, NULL);
 
     /* Have a pointer in the older frame point to a local in the
        more recent frame.  */
-    svalue2 *sval_ptr = model0.get_rvalue (addr_of_a, NULL);
+    const svalue2 *sval_ptr = model0.get_rvalue (addr_of_a, NULL);
     model0.set_value (q_in_first_frame, sid_ptr, NULL);
 
     /* Verify that it's pointing at the newer frame.  */
-    region2 *reg_pointee
+    const region2 *reg_pointee
       = model0.get_svalue2 (sid_ptr)->dyn_cast_region_svalue2 ()->get_pointee ();
     ASSERT_EQ (model0.get_region2 (rid_pointee)->get_parent (), rid_2nd_frame);
 
@@ -8716,14 +8736,14 @@ test_malloc_constraints ()
   tree q = build_global_decl ("q", char_star);
   tree null_ptr = build_int_cst (ptr_type_node, 0);
 
-  region2 *reg = model.add_new_malloc_region2 ();
-  svalue2 *sval = mgr.get_ptr_svalue2 (ptr_type_node, rid);
+  const region2 *reg = model.add_new_malloc_region2 ();
+  const svalue2 *sval = mgr.get_ptr_svalue2 (ptr_type_node, rid);
   model.set_value (model.get_lvalue (p, NULL), sid, NULL);
   model.set_value (q, p, NULL);
 
   /* We should have a symbolic_region2 with m_possibly_null: true.  */
-  region2 *pointee = model.get_region2 (rid);
-  symbolic_region2 *sym_reg = pointee->dyn_cast_symbolic_region2 ();
+  const region2 *pointee = model.get_region2 (rid);
+  const symbolic_region2 *sym_reg = pointee->dyn_cast_symbolic_region2 ();
   ASSERT_NE (sym_reg, NULL);
   ASSERT_TRUE (sym_reg->m_possibly_null);
 
@@ -8756,11 +8776,11 @@ test_var ()
   region_model2_manager mgr;
   region_model2 model (&mgr);
 
-  region2 *i_reg = model.get_lvalue (i, NULL);
+  const region2 *i_reg = model.get_lvalue (i, NULL);
   ASSERT_EQ (i_reg->get_kind (), region2::RK_DECL);
 
   /* Reading "i" should give a symbolic "initial value".  */
-  svalue2 *sval_init = model.get_rvalue (i, NULL);
+  const svalue2 *sval_init = model.get_rvalue (i, NULL);
   ASSERT_EQ (sval_init->get_kind (), svalue2::SK_INITIAL);
   ASSERT_EQ (sval_init->dyn_cast_initial_svalue2 ()->get_region (), i_reg);
   /* ..and doing it again should give the same "initial value".  */
@@ -8841,7 +8861,7 @@ test_array ()
 
   /* Verify get_offset for "arr[0]".  */
   {
-    region2 *arr_0_reg = model.get_lvalue (arr_0, NULL);
+    const region2 *arr_0_reg = model.get_lvalue (arr_0, NULL);
     region_offset offset = arr_0_reg->get_offset ();
     ASSERT_EQ (offset.get_base_region (), model.get_lvalue (arr, NULL));
     ASSERT_EQ (offset.get_bit_offset (), 0);
@@ -8849,7 +8869,7 @@ test_array ()
 
   /* Verify get_offset for "arr[1]".  */
   {
-    region2 *arr_1_reg = model.get_lvalue (arr_1, NULL);
+    const region2 *arr_1_reg = model.get_lvalue (arr_1, NULL);
     region_offset offset = arr_1_reg->get_offset ();
     ASSERT_EQ (offset.get_base_region (), model.get_lvalue (arr, NULL));
     ASSERT_EQ (offset.get_bit_offset (), INT_TYPE_SIZE);
@@ -8911,7 +8931,7 @@ test_mem_ref ()
   /* "p = &x;".  */
   model.set_value (p, addr_of_x, NULL);
 
-  svalue2 *sval = model.get_rvalue (star_p, NULL);
+  const svalue2 *sval = model.get_rvalue (star_p, NULL);
   ASSERT_EQ (sval->maybe_get_constant (), int_17);
 }
 
@@ -8954,8 +8974,8 @@ test_POINTER_PLUS_EXPR_then_MEM_REF ()
 			 pointer_plus_expr, offset_0);
   region_model2_manager mgr;
   region_model2 m (&mgr);
-  svalue2 *tmp_2 = m.get_rvalue (mem_ref, NULL);
-  region2 *tmp_5 = m.get_lvalue (mem_ref, NULL);
+  const svalue2 *tmp_2 = m.get_rvalue (mem_ref, NULL);
+  const region2 *tmp_5 = m.get_lvalue (mem_ref, NULL);
 
   tree int_42 = build_int_cst (integer_type_node, 42);
   m.set_value (mem_ref, int_42, NULL);
@@ -8980,9 +9000,9 @@ test_malloc ()
   region_model2 model (&mgr);
 
   /* "p = malloc (n * 4);".  */
-  svalue2 *size_sval = model.get_rvalue (n_times_4, &ctxt);
-  region2 *reg = model.create_region_for_heap_alloc (size_sval);
-  svalue2 *ptr = mgr.get_ptr_svalue2 (int_star, reg);
+  const svalue2 *size_sval = model.get_rvalue (n_times_4, &ctxt);
+  const region2 *reg = model.create_region_for_heap_alloc (size_sval);
+  const svalue2 *ptr = mgr.get_ptr_svalue2 (int_star, reg);
   model.set_value (model.get_lvalue (p, &ctxt), ptr, &ctxt);
   // TODO: verify dynamic extents
 
@@ -9011,13 +9031,13 @@ test_alloca ()
   region_model2 model (&mgr);
 
   /* Push stack frame.  */
-  region2 *frame_reg
+  const region2 *frame_reg
     = model.push_frame (DECL_STRUCT_FUNCTION (fndecl),
 			NULL, &ctxt);
   /* "p = alloca (n * 4);".  */
-  svalue2 *size_sval = model.get_rvalue (n_times_4, &ctxt);
-  region2 *reg = model.create_region_for_alloca (size_sval);
-  svalue2 *ptr = mgr.get_ptr_svalue2 (int_star, reg);
+  const svalue2 *size_sval = model.get_rvalue (n_times_4, &ctxt);
+  const region2 *reg = model.create_region_for_alloca (size_sval);
+  const svalue2 *ptr = mgr.get_ptr_svalue2 (int_star, reg);
   model.set_value (model.get_lvalue (p, &ctxt), ptr, &ctxt);
   // TODO: verify dynamic extents
   // TODO: try popping the frame; verify that the alloca region is poisoned
